/***********************************************************************
*     ACCESS SAMPLE PROGRAM                                            *
*                                                             BY CAD'S *
*                                                                      *
*          The program of changing Line Type                           *
*                                                                      *
***********************************************************************/

#include    <string.h>
#include    <stdlib.h>

#include    "accfnc.h"
#define     INCL_BLK_MSG_SP6
#include    "cgltmsg.dfn"
#include    "cgltdlg.dfn"

static void get_ppvalue ( void );
static void get_ltype ( long, long *, long * );
static long chg_ltype( long );
static void chg_ltype_cview ( long );
static long chg_ltype_view ( long );
static long chg_ltype_detail ( long );

#define     FKHIT           6
#define     POPEVENT        7
#define     FALSE           0
#define     TRUE            1
#define     PP_CVIEW        0
#define     PP_AVIEW        1
#define     PP_ADETAIL      2

/* POP-UP value */
static  long    pp_ltypeb_12;
static  long    pp_ltypeb_no;
static  long    pp_ltypea_12;
static  long    pp_ltypea_no;
static  long    pp_ltypea_no_buetyp;
static  long    pp_view;
static  long    pp_parts;
static  long    pp_line;
static  long    pp_mline;
static  long    pp_sketch;
static  long    pp_circle;
static  long    pp_ellipse;
static  long    pp_spline;
static  long    pp_lspline;


void ac2userp( void )
{
    long    iflgar[3];                  /* bubegn       */
    long    ioutar[3];                  /* bubegn       */
    long    modear[3];                  /* bumode       */
    long    prsbtn;                     /* MC_msgbox    */
    long    pos[2];                     /* MC_poplsthlt */
    long    linetype_mode;              /* MC_ls1mode   */
    long    save_linetype_mode;         /* MC_ls1mode   */
    long    mask[7];                    /* MC_event     */
    long    event;                      /* MC_event     */
    long    popno;                      /* MC_popevent  */
    long    objno;                      /* MC_popevent  */
    long    pevent;                     /* MC_popevent  */
    long    modno;                      /* MC_curmdl    */
    long    eflag;
    long    msgblk;
    long    popopn;
    long    iret;
    short   retc;

    /* Initial of ACCESS and Set Trace Mode */
    eflag = TRUE;
    msgblk = 0L;
    popopn = 1L;

    iflgar[0] = 52L;
    iflgar[1] = 0L;
    iflgar[2] = 0L;
    retc = MC_bubegn ( 1L, iflgar, ioutar, 10L );
    if ( retc ) goto exit;

    modear[0] = 2L;
    modear[1] = 0L;
    modear[2] = 12L;
    retc = MC_bumode ( 1L, modear, 10L );
    if ( retc ) goto exit;

    /* Open Resource File */
    retc = MC_msginit ( 7L, "cgltmsg" );
    if ( retc ) goto exit;

    retc = MC_popinit ( 7L, "cgltdlg" );
    if ( retc ) goto exit;

    /* Set the block of message */
    retc = MC_msgsetbk ( BLK_MSG_SP6 );
    if ( retc ) goto exit;
    msgblk = 1L;


    /* Open the pop-up window */
    retc = MC_popopen ( SP6_MAINWND );
    if ( retc )
    {
        MC_msgbox ( MSG_POPOPEN_ERR, 1L, 1L, &prsbtn );
        goto exit;
    }
    popopn = 1L;


    /* Set the Line Type "Solid" */
    pos[0] = 1L;
    pos[1] = 1L;
    MC_poplsthlt( SP6_MAINWND, SP6_CBX_BEFORE, pos );
    MC_poplsthlt( SP6_MAINWND, SP6_CBX_AFTER, pos );

    /* Set the mode "Current View" */
    MC_popbtn_set ( SP6_MAINWND, SP6_RB_CURRENT, 1L );

    /* Display pop-up window */
    MC_popdisp ( SP6_MAINWND );

    /* Set newJIS mode */
    MC_ls1mode ( 2L, &save_linetype_mode );
    linetype_mode = 1L;
    MC_ls1mode ( 1L, &linetype_mode );


    /* Loop */
    while ( eflag )
    {
        mask[0] = 0L;
        mask[1] = 0L;
        mask[2] = 0L;
        mask[3] = 0L;
        mask[4] = 0L;
        mask[5] = 1L;   /* FKHIT */
        mask[6] = 1L;   /* POPEVENT */
        MC_event( mask, &event );
        if( event == FKHIT ){
            break;
        }

        /* Pop-up Window */
        if ( event == POPEVENT )
        {
            /* Get Object */
            MC_popevent ( &popno, &objno, &pevent );

            switch ( objno )
            {

                case SP6_PB_EXECUTE:

                    /* Get the value of pop-up */
                    get_ppvalue( );

                    /* Error Check of pop-up value */
                    if ( pp_ltypea_12 == pp_ltypeb_12 && pp_ltypea_no == pp_ltypeb_no )
                    {
                        MC_msgbox ( MSG_SAME_LINE_TYPE, 1L, 1L, &prsbtn );
                        break;
                    }
                    else if ( !pp_line && !pp_mline && !pp_sketch && !pp_circle &&
                              !pp_ellipse && !pp_spline && !pp_lspline )
                    {
                        MC_msgbox ( MSG_NO_TARGET_ELEMENT, 1L, 1L, &prsbtn );
                        break;
                    }

                    /* Get Current Model No. */
                    MC_curmdl( 1L, &modno );

                    /* The process of changing line type */
                    iret = chg_ltype( modno );
                    if ( iret == 0L )
                    {
                        MC_msgbox ( MSG_COMPLETE, 1L, 1L, &prsbtn );
                    }
                    else
                    {
                        MC_msgbox ( MSG_OUT_OF_MEMORY, 1L, 1L, &prsbtn );
                    }

                    break;

                case SP6_PB_END:
                    eflag = FALSE;
                    break;

                default: break;
            }   /* end of switch */

        }   /* end of if ( POPEVENT ) */

    }   /* end of while */

exit:

    /* Restore the new JIS mode */
    MC_ls1mode ( 1L, &save_linetype_mode );

    /* End of Message Block */
    if( msgblk )    MC_msgendbk( BLK_MSG_SP6 );

    /* Close Pop-up Window */
    if( popopn )    MC_popclose( SP6_MAINWND );

    MC_buend( 1L, 10L );

    return;
}



/***********************************************************************
*                                                                      *
*       Get the value of pop-up                                        *
*                                                                      *
***********************************************************************/
static void get_ppvalue( void )
{
    long    hpos[1][2];                 /* MC_poplsthps     */
    long    number;                     /* MC_poplsthps     */
    long    press;                      /* MC_popbtn_get    */

    /* Line Type */
    number = 1L;
    MC_poplsthps ( SP6_MAINWND, SP6_CBX_BEFORE, 1L, &number, hpos );
    get_ltype ( hpos[0][0], &pp_ltypeb_12, &pp_ltypeb_no );

    number = 1L;
    MC_poplsthps ( SP6_MAINWND, SP6_CBX_AFTER, 1L, &number, hpos );
    get_ltype ( hpos[0][0], &pp_ltypea_12, &pp_ltypea_no );
    if ( pp_ltypea_12 == 2L ) pp_ltypea_no_buetyp = pp_ltypea_no + 200L;

    /* View/Detail */
    MC_popbtn_get( SP6_MAINWND, SP6_RB_CURRENT, &press );
    if ( press )    pp_view = PP_CVIEW;
    MC_popbtn_get( SP6_MAINWND, SP6_RB_ALL_VIEW, &press );
    if ( press )    pp_view = PP_AVIEW;
    MC_popbtn_get( SP6_MAINWND, SP6_RB_ALL_DETAIL, &press );
    if ( press )    pp_view = PP_ADETAIL;

    /* Parts */
    MC_popbtn_get( SP6_MAINWND, SP6_CB_PARTS, &press );
    if ( press )    pp_parts = TRUE;
    else            pp_parts = FALSE;

    /* Element type */
    MC_popbtn_get( SP6_MAINWND, SP6_CB_LINE, &press );
    if ( press )    pp_line = TRUE;
    else            pp_line = FALSE;
    MC_popbtn_get( SP6_MAINWND, SP6_CB_MULTILINE, &press );
    if ( press )    pp_mline = TRUE;
    else            pp_mline = FALSE;
    MC_popbtn_get( SP6_MAINWND, SP6_CB_SKETCH, &press );
    if ( press )    pp_sketch = TRUE;
    else            pp_sketch = FALSE;
    MC_popbtn_get( SP6_MAINWND, SP6_CB_CIRCLE, &press );
    if ( press )    pp_circle = TRUE;
    else            pp_circle = FALSE;
    MC_popbtn_get( SP6_MAINWND, SP6_CB_ELLIPSE, &press );
    if ( press )    pp_ellipse = TRUE;
    else            pp_ellipse = FALSE;
    MC_popbtn_get( SP6_MAINWND, SP6_CB_SPLINE, &press );
    if ( press )    pp_spline = TRUE;
    else            pp_spline = FALSE;
    MC_popbtn_get( SP6_MAINWND, SP6_CB_LINEARSPLINE, &press );
    if ( press )    pp_lspline = TRUE;
    else            pp_lspline = FALSE;

    return;
}



/***********************************************************************
*                                                                      *
*       Convert linetype from pop-up to access core                    *
*                                                                      *
*           pp_ltype     :  Linetype of pop-up                         *
*                                                                      *
*           ac_ltype_12  :  Style1 / Style2                            *
*                                                                      *
*           ac_ltype_no  :  Linetype of Access core                    *
*                                                                      *
***********************************************************************/
static void get_ltype ( long pp_ltype, long *ac_ltype_12, long *ac_ltype_no )
{

    switch ( pp_ltype )
    {
        case  1:    *ac_ltype_12 = 1L;  *ac_ltype_no =  2L;     break;
        case  2:    *ac_ltype_12 = 1L;  *ac_ltype_no =  0L;     break;
        case  3:    *ac_ltype_12 = 1L;  *ac_ltype_no =  1L;     break;
        case  4:    *ac_ltype_12 = 1L;  *ac_ltype_no = 10L;     break;
        case  5:    *ac_ltype_12 = 1L;  *ac_ltype_no = 11L;     break;
        case  6:    *ac_ltype_12 = 1L;  *ac_ltype_no = 20L;     break;
        case  7:    *ac_ltype_12 = 1L;  *ac_ltype_no = 21L;     break;
        case  8:    *ac_ltype_12 = 1L;  *ac_ltype_no = 31L;     break;
        case  9:    *ac_ltype_12 = 1L;  *ac_ltype_no = 40L;     break;
        case 10:    *ac_ltype_12 = 1L;  *ac_ltype_no = 41L;     break;
        case 11:    *ac_ltype_12 = 2L;  *ac_ltype_no =  1L;     break;
        case 12:    *ac_ltype_12 = 2L;  *ac_ltype_no =  2L;     break;
        case 13:    *ac_ltype_12 = 2L;  *ac_ltype_no =  3L;     break;
        case 14:    *ac_ltype_12 = 2L;  *ac_ltype_no =  4L;     break;
        case 15:    *ac_ltype_12 = 2L;  *ac_ltype_no =  5L;     break;
        case 16:    *ac_ltype_12 = 2L;  *ac_ltype_no =  6L;     break;
        case 17:    *ac_ltype_12 = 2L;  *ac_ltype_no = 10L;     break;
        case 18:    *ac_ltype_12 = 2L;  *ac_ltype_no = 11L;     break;
        case 19:    *ac_ltype_12 = 2L;  *ac_ltype_no = 12L;     break;
        case 20:    *ac_ltype_12 = 2L;  *ac_ltype_no = 13L;     break;
        case 21:    *ac_ltype_12 = 2L;  *ac_ltype_no = 14L;     break;
        case 22:    *ac_ltype_12 = 2L;  *ac_ltype_no =  7L;     break;
        case 23:    *ac_ltype_12 = 2L;  *ac_ltype_no =  8L;     break;
        case 24:    *ac_ltype_12 = 2L;  *ac_ltype_no =  9L;     break;
        case 25:    *ac_ltype_12 = 2L;  *ac_ltype_no = 15L;     break;
        case 26:    *ac_ltype_12 = 2L;  *ac_ltype_no = 16L;     break;
        case 27:    *ac_ltype_12 = 2L;  *ac_ltype_no = 17L;     break;
        case 28:    *ac_ltype_12 = 2L;  *ac_ltype_no = 18L;     break;
    } /* end of switch */

    return;
}



/***********************************************************************
*                                                                      *
*       Change the linetype of the model                               *
*                                                                      *
*           modno  :  Model No                                         *
*                                                                      *
*           Return Code :  0  OK                                       *
*                          1  Error(MemoryFull)                        *
*                                                                      *
***********************************************************************/
static long chg_ltype ( long modno )
{
    long    number;                     /* MC_bucds */
    long    ivudet;                     /* MC_bucds */
    long    save_ivudet;                /* MC_bucds */
    long    iret = 0L;

    /* Save Current Model and View */
    MC_bucds ( 2L, modno, 1L, &save_ivudet, &number, 10L );

    /* Current View */
    if ( pp_view == PP_CVIEW )
    {
        chg_ltype_cview ( modno );
    }
    /* All View */
    else if ( pp_view == PP_AVIEW )
    {
        iret = chg_ltype_view ( modno );
    }
    /* All Detail */
    else if ( pp_view == PP_ADETAIL )
    {
        iret = chg_ltype_detail ( modno );
    }

    /* Change Forcus to Original Mode(View) */
    ivudet = save_ivudet;
    MC_bucds ( 1L, modno, 1L, &ivudet, &number, 10L );

    MC_budisp ( 1L, modno, 0L, 10L );

    return ( iret );
}



/***********************************************************************
*                                                                      *
*       Change the linetype of the current view                        *
*                                                                      *
*           modno  :  Model No                                         *
*                                                                      *
***********************************************************************/
static void chg_ltype_cview ( long modno )
{
    long    iret;
    long    mptr;           /* MC_bunext */
    long    nxtptr;         /* MC_bunext,MC_biityp,MC_biltyp,MC_gstl2,MC_buetyp,MC_pmode */
    long    itype;          /* MC_biityp,MC_buetyp */
    long    ltype1;         /* MC_biltyp */
    long    ltype2;         /* MC_gstl2 */
    long    numdsh;         /* MC_gstl2 */
    long    save_paptr;     /* MC_pmode */
    long    newptr;         /* MC_buetyp */
    double  adjust;         /* MC_gstl2 */
    double  dshpat[20];     /* MC_gstl2 */


    mptr = 1L;
    for ( ; ; )
    {
        iret = MC_bunext ( 1L, modno, mptr, &nxtptr, 10L );
        if ( iret != 0L )
        {
            break;
        }
        mptr = nxtptr;

        itype = MC_biityp ( modno, nxtptr );
        switch ( itype )
        {
        /* Line */
        case 200:
            if ( !pp_line ) continue;
            break;

        /* Multi Line */
        case 210:
        case 211:
            if ( !pp_mline ) continue;
            break;

        /* Sketch */
        case 600:
            if ( !pp_sketch ) continue;
            break;

        /* Circle */
        case 300:
            if ( !pp_circle ) continue;
            break;

        /* Ellipse */
        case 400:
            if ( !pp_ellipse ) continue;
            break;

        /* Spline */
        case 500:
        case 501:
        case 510:
        case 550:
            if ( !pp_spline ) continue;
            break;

        /* Linear Spline */
        case 540:
        case 541:
            if ( !pp_lspline ) continue;
            break;

        /* Parts */
        case 1700:
        case 1750:
            if ( !pp_parts ) continue;
            goto PROC_PARTS;

        default:
            continue;
        } /* end of switch */


        /* STYLE1 */
        if ( pp_ltypeb_12 == 1L )
        {
            ltype1 = MC_biltyp ( modno, nxtptr );
            if ( ltype1 == 0L && pp_ltypeb_no == 0L )
            {
                iret = MC_gstl2 ( modno, nxtptr, &ltype2, &adjust, &numdsh, dshpat );
                if ( iret == 0L && ltype2 != 0L ) continue;
            }
            else
            {
                if ( ltype1 != pp_ltypeb_no ) continue;
            }
        }
        /* STYLE2 */
        else
        {
            iret = MC_gstl2 ( modno, nxtptr, &ltype2, &adjust, &numdsh, dshpat );
            if ( iret != 0L ) continue;
            if ( ltype2 != pp_ltypeb_no ) continue;
        }


        /* STYLE1 */
        if ( pp_ltypea_12 == 1L )
        {
            MC_buetyp ( 1L, modno, nxtptr, itype, pp_ltypea_no, &newptr, 10L );
        }
        /* STYLE2 */
        else
        {
            MC_buetyp ( 1L, modno, nxtptr, itype, pp_ltypea_no_buetyp, &newptr, 10L );
        }

        continue;


PROC_PARTS:

        MC_pmode ( 2L, modno, &save_paptr );
        MC_pmode ( 1L, modno, &nxtptr );

        /* Change the linetype of the parts */
        chg_ltype_cview ( modno );

        if ( save_paptr == 0L )
        {
            MC_pmode ( 0L, modno, &save_paptr );
        }
        else
        {
            MC_pmode ( 1L, modno, &save_paptr );
        }

        continue;

    }

    return;
}



/***********************************************************************
*                                                                      *
*       Change the linetype of all view                                *
*                                                                      *
*           modno  :  Model No                                         *
*                                                                      *
*           Return Code :  0  OK                                       *
*                          1  Error(MemoryFull)                        *
*                                                                      *
***********************************************************************/
static long chg_ltype_view ( long modno )
{
    long    view_num;           /* MC_gvdnum    */
    long    ivdtln;             /* MC_budrct    */
    long    *ivdtar = NULL;     /* MC_budrct    */
    long    ivudet;             /* MC_bucds     */
    long    number;             /* MC_bucds     */
    long    ii;

    /* Get the number of View */
    MC_gvdnum( 1L, modno, &view_num );

    /* Allocate the area */
    ivdtar = malloc ( sizeof(long) * view_num );
    if ( ivdtar == NULL )
    {
        return ( 1L );
    }
    memset ( ivdtar, 0x00, sizeof(long)*view_num );

    /* Get View number list */
    MC_budrct ( 1L, modno, &ivdtln, ivdtar, 10L );


    /* Change the linetype of all view */
    for ( ii=0; ii<view_num; ii++ )
    {
        ivudet = ivdtar[ii];
        MC_bucds ( 1L, modno, 1L, &ivudet, &number, 10L );

        /* Change the linetype of the current view */
        chg_ltype_cview ( modno );
    }

    /* Free */
    if ( ivdtar != NULL )
    {
        free ( ivdtar );
        ivdtar = NULL;
    }

    return ( 0L );
}



/***********************************************************************
*                                                                      *
*       Change the linetype of all detail                              *
*                                                                      *
*           modno  :  Model No                                         *
*                                                                      *
*           Return Code :  0  OK                                       *
*                          1  Error(MemoryFull)                        *
*                                                                      *
***********************************************************************/
static long chg_ltype_detail ( long modno )
{
    long    detail_num;         /* MC_gvdnum    */
    long    ivdtln;             /* MC_budrct    */
    long    *ivdtar = NULL;     /* MC_budrct    */
    long    number;             /* MC_bucds     */
    long    ivudet;             /* MC_bucds     */
    long    ii;


    /* Get the number of Detail */
    MC_gvdnum( 2L, modno, &detail_num );
    /* No Detail */
    if ( detail_num == 0L )
    {
        return ( 0L );
    }

    /* Allocate the area */
    ivdtar = malloc ( sizeof(long) * detail_num );
    if ( ivdtar == NULL )
    {
        return ( 1L );
    }
    memset ( ivdtar, 0x00, sizeof(long)*detail_num );

    /* Get Detail number list */
    MC_budrct ( 3L, modno, &ivdtln, ivdtar, 10L );

    /* Change the linetype of all detail */
    for ( ii=0; ii<detail_num; ii++ )
    {
        ivudet = ivdtar[ii];
        MC_bucds ( 1L, modno, 1L, &ivudet, &number, 10L );

        /* Change the linetype of the current detail */
        chg_ltype_cview ( modno );
    }


    /* Free */
    if ( ivdtar != NULL )
    {
        free ( ivdtar );
        ivdtar = NULL;
    }

    return ( 0L );
}


